#!/usr/bin/env python2

# Sumit Khanna - PenguinDreams.org
#   Free for educational and non-commercial use

from M2Crypto import EVP, RSA, X509
import sys
import base64
from os import path
import fileinput


if __name__ == '__main__':

  if len(sys.argv) < 3 and len(sys.argv) > 4:
    sys.stderr.write('Usage ./pyverify.py <pem file> <data file to verify> [signature file]\n')
    sys.stderr.write('\tIf no signature file is given, signature is taken via stdin\n')
    sys.exit(1)

  pemFile = sys.argv[1]
  dataFile = sys.argv[2]
  sigFile = sys.argv[3] if len(sys.argv) == 4 else '-'

  key = EVP.load_key(pemFile)

  if not path.isfile(pemFile):
    sys.stderr.write('PEM File could not be found\n')
    sys.exit(2)

  if not path.isfile(dataFile):
    sys.stderr.write('Data File could not be found\n')

  for line in fileinput.input(sigFile):
    key.reset_context(md='sha1')
    key.verify_init()
    key.verify_update(open(dataFile,'r').read())
    if key.verify_final(base64.b64decode(line)):
      print "Signature Verified"
      sys.exit(0)
    else:
      print "Signature Verification Failed"
      sys.exit(2)
   

